import java.awt.*;
import java.awt.event.*;
import java.util.*;


public class Tree extends DrawBox implements Cloneable
{
public int depth,angle,length;
static Random r=new Random();

public Tree()
	{
	super();
	depth = (int)(r.nextDouble()*10.0);
	angle = (int)(r.nextDouble()*360.0);
	length = (int)(r.nextDouble()*50.0);
	}

public Tree(int d,int a,int l)
	{
	super();
	depth = d;
	angle = a;
	length = l;
//	resize(50,50);
	}

public Tree(int d,int a,int l,Color background)
	{
	super(background);
	depth = d;
	angle = a;
	length = l;
//	resize(50,50);
	}

public Tree(Color background)
	{
	super(background);
	depth = (int)(r.nextDouble()*10.0);
	angle = (int)(r.nextDouble()*360.0);
	length = (int)(r.nextDouble()*50.0);
//	resize(50,50);
	}


public void paint(Graphics g)
	{
	clear(g);
	drawBorder(g);
	DrawTree(g);
	}

public void updateTree(Tree tr)
	{
	this.depth = tr.depth;
	this.angle = tr.angle;
	this.length = tr.length;
	repaint();
	}


public void DrawTree(Graphics g)
	{
	Dimension d = getSize();

	Turtle root = new Turtle(d.width/2,d.height/2,270); // start at 270 degrees for straight up
	drawBranches(root,0,g);
	} // end draw tree from root

private void drawBranches(Turtle parent,int b,Graphics g)// recursive tree drawer
	{
	Turtle left = new Turtle(0,0,0);
	Turtle right = new Turtle(0,0,0);
	int branch;
	int temp;

	branch = b+1;

	if (branch<=this.depth)
		{
		left = (Turtle)parent.clone();
		right = (Turtle)parent.clone();
	
		left.LeftTurn(this.angle);
		right.RightTurn(this.angle);

		left.Forward(this.length,g);
		right.Forward(this.length,g);
	
		drawBranches(left,branch,g);
		drawBranches(right,branch,g);
		}
	} // end draw branches


public void mutate()
	{
	switch(r.nextInt()%3)
		{
		case 0:
		if ( (r.nextInt()%2)==1 )
			{
			if (depth>2)
			depth += ((r.nextInt()%3)-1);
			}
		break;	
	
		case 1:
		angle += ((r.nextInt()%5)-2);
		break;

		case 2:
		length += ((r.nextInt()%5)-2);
		break;
		}

	}

public Object clone()
	{
	return new Tree(this.depth,this.angle,this.length);
	}

} // end Tree class

